---
title: XREnvironmentBlendMode
slug: Web/API/XREnvironmentBlendMode
tags:
  - API
  - AR
  - Enum
  - Enumerated Type
  - Graphics
  - Reality
  - Reference
  - Type
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - augmented
---
<p>{{APIRef("WebXR Device API")}}</p>

<p><span class="seoSummary">The WebXR API's enumerated type <code><strong>XREnvironmentBlendMode</strong></code> defines strings used to identify if and how to blend the rendered virtual content with the real world. Its values are used by the {{domxref("XRSession")}} interface's {{domxref("XRSession.environmentBlendMode", "environmentBlendMode")}} property.</span></p>

<h2 id="Values">Values</h2>

<dl>
 <dt><a id="opaque"><code>opaque</code></a></dt>
 <dd>The rendered image is drawn without allowing any pass-through imagery. This is primarily used by fully-immersive VR headsets, which totally obscure the surrounding environment, with none of the real world shown to the user at all. The alpha values specified in the {{domxref("XRSession")}}'s {{domxref("XRSession.renderState", "renderState")}} property's <code>baseLayer</code> field are ignored since the alpha values for the rendered imagery are all treated as being 1.0 (fully opaque).</dd>
 <dt><a id="additive"><code>additive</code></a></dt>
 <dd>Primarily used by AR devices with transparent lenses which directly allow reality to pass through to the user's eyes, the <code>additive</code> blending mode is designed to be used in a situation in which the device has no control over the background and its brightness, since that isn't being digitally controlled. All the device can do is add more light to the image; it can't make things get darker. Therefore, black is rendered as fully transparent, and there's no way to make a pixel fully opaque. As with the <code>opaque</code> setting, alpha values specified are ignored and treated as if they were 1.0.</dd>
 <dt><a id="alpha-blend"><code>alpha-blend</code></a></dt>
 <dd>Used by headsets or goggles which use cameras to capture the real world and display it digitally on the screen or screens used to render the content for the user to see, this offers a way to create an AR presentation using a VR device. Alpha blending can also be used by non-wearable devices that provide AR modes, such as phones or tablets using cameras to capture the real world for use in AR apps. Since the real world is being digitally presented, the brightness of each pixel can be controlled, whether it's reality or the rendered XR image, the user's environment can be blended with the virtual environment with each pixel having its color and brightness precisely controlled.</dd>
 <dd>In this mode, the <code>XRSession</code>'s <code>renderState.baseLayer</code> property provides relative weights of the artificial layer during the compositing process. Pixels whose alpha value is 1.0 are rendered fully opaque, totally obscuring the real world, while pixels with an alpha of 1.0 are totally transparent, leaving the surrounding environment to pass through.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR AR Module","#xrenvironmentblendmode-enum","XREnvironmentBlendMode")}}</td>
   <td>{{Spec2("WebXR AR Module")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XREnvironmentBlendMode")}}</p>
